Loading...
Searching...
No Matches
DisplayControl.idl
/* SPDX-License-Identifier: BSD-3-Clause */
/*
* Copyright 2014 Raritan Inc. All rights reserved.
*/
#include <UserEvent.idl>
/** Front panel display interface */
module display {
/**
* Interface to control the device's front panel display
*/
interface DisplayControl {
/**
* Error codes
*/
constant int SUCCESS = 0; ///< No error
constant int ERR_INVALID_VALUE = 1; ///< Invalid argument
/** Collected display meta information */
structure Info {
int fwAppVersion; ///< Firmware application version; 0 if unavailable
int fwBootVersion; ///< Firmware bootloader version; 0 if unavailable
int orientation; ///< Display orientation
int width; ///< Display width
int height; ///< Display height
boolean versionAvailable; ///< \c true if version information is available
};
/**
* Representation of a possible default view
*/
structure DefaultViewItem {
string id; ///< View ID
string description; ///< Textual description
};
structure Settings {
string defaultView; ///< Default view ID (might be an empty string
///< if the device doesn't allow default view configuration)
int backlightTimeout; ///< Backlight timeout in seconds, or 0 for no timeout
};
/** Event: Settings were changed */
valueobject SettingsChangedEvent extends event.UserEvent {
Settings newSettings; ///< New settings
};
/**
* Get available default views. This returns all views that can be
* used as default views on the device display.
*
* @return Possible default views, or empty list if the default view
* can not be configured for the device's display
*/
vector<DefaultViewItem> getAvailableDefaultViews();
/**
* Get the current settings
*
* @return settings
*/
Settings getSettings();
/**
* Update the settings
*
* @param settings Settings to be applied
*
* @return 0 on success
* @return 1 on invalid value
*/
int setSettings(in Settings settings);
/**
* Retrieve display's meta information.
*
* @return Display information
*/
Info getInfo();
/**
* Show smiley on display
*
* @param on \c true to turn on smiley
* @param happy \c true to show happy smiley,\c false to show sad smiley
* @param msg String for message
*/
void showSmiley(in boolean on, in boolean happy, in string msg);
};
}
display::DisplayControl
Interface to control the device's front panel display.
Definition DisplayControl.idl:13
display::DisplayControl::getInfo
Info getInfo()
Retrieve display's meta information.
display::DisplayControl::ERR_INVALID_VALUE
constant int ERR_INVALID_VALUE
Invalid argument.
Definition DisplayControl.idl:18
display::DisplayControl::setSettings
int setSettings(in Settings settings)
Update the settings.
display::DisplayControl::showSmiley
void showSmiley(in boolean on, in boolean happy, in string msg)
Show smiley on display.
display::DisplayControl::getAvailableDefaultViews
vector< DefaultViewItem > getAvailableDefaultViews()
Get available default views.
display::DisplayControl::SUCCESS
constant int SUCCESS
Error codes.
Definition DisplayControl.idl:17
display::DisplayControl::getSettings
Settings getSettings()
Get the current settings.
display
Front panel display interface.
Definition DisplayControl.idl:9
display::DisplayControl::DefaultViewItem
Representation of a possible default view.
Definition DisplayControl.idl:33
display::DisplayControl::DefaultViewItem::id
string id
View ID.
Definition DisplayControl.idl:34
display::DisplayControl::DefaultViewItem::description
string description
Textual description.
Definition DisplayControl.idl:35
display::DisplayControl::Info
Collected display meta information.
Definition DisplayControl.idl:21
display::DisplayControl::Info::width
int width
Display width.
Definition DisplayControl.idl:25
display::DisplayControl::Info::height
int height
Display height.
Definition DisplayControl.idl:26
display::DisplayControl::Info::fwBootVersion
int fwBootVersion
Firmware bootloader version; 0 if unavailable.
Definition DisplayControl.idl:23
display::DisplayControl::Info::versionAvailable
boolean versionAvailable
true if version information is available
Definition DisplayControl.idl:27
display::DisplayControl::Info::fwAppVersion
int fwAppVersion
Firmware application version; 0 if unavailable.
Definition DisplayControl.idl:22
display::DisplayControl::Info::orientation
int orientation
Display orientation.
Definition DisplayControl.idl:24
display::DisplayControl::SettingsChangedEvent
Event: Settings were changed.
Definition DisplayControl.idl:45
display::DisplayControl::SettingsChangedEvent::newSettings
Settings newSettings
New settings.
Definition DisplayControl.idl:46
display::DisplayControl::Settings
Definition DisplayControl.idl:38
display::DisplayControl::Settings::backlightTimeout
int backlightTimeout
Backlight timeout in seconds, or 0 for no timeout.
Definition DisplayControl.idl:41
display::DisplayControl::Settings::defaultView
string defaultView
Default view ID (might be an empty string if the device doesn't allow default view configuration)
Definition DisplayControl.idl:39